package vins

import (
	"context"
	"net/http"
	"strconv"

	"repository.basistech.ru/BASIS/dynamix-golang-sdk/v14/internal/validators"
)

// MigrateToZone struct to move VINS to another zone
type MigrateToZoneRequest struct {
	// VINSID to move
	// Required: true
	VINSID uint64 `url:"net_id" json:"net_id" validate:"required"`

	// ID of the zone to move
	// Required: true
	ZoneID uint64 `url:"zone_id" json:"zone_id" validate:"required"`
}

// MigrateToZone moves VINS instance to new zone
func (v VINS) MigrateToZone(ctx context.Context, req MigrateToZoneRequest) (bool, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return false, validators.ValidationErrors(validators.GetErrors(err))
	}

	url := "/cloudbroker/vins/migrateToZone"

	res, err := v.client.DecortApiCall(ctx, http.MethodPost, url, req)
	if err != nil {
		return false, err
	}

	result, err := strconv.ParseBool(string(res))
	if err != nil {
		return false, err
	}

	return result, nil
}
